/*
*	New C++ File starts here.
*	This file should be named pidn.cpp
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "pidn.hh"

// Forward Function Prototypes

/*
*	NML/CMS Format function : pidFormat
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
int pidFormat(NMLTYPE type, void *buffer, CMS *cms)
{
	switch(type)
	{
	case PID_HALT_TYPE:
		((PID_HALT *) buffer)->update(cms);
		break;
	case PID_INIT_TYPE:
		((PID_INIT *) buffer)->update(cms);
		break;
	case PID_RUN_TYPE:
		((PID_RUN *) buffer)->update(cms);
		break;
	case PID_SET_GAINS_TYPE:
		((PID_SET_GAINS *) buffer)->update(cms);
		break;
	case PID_STATUS_TYPE:
		((PID_STATUS *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *pid_symbol_lookup(int type)
{
	switch(type)
	{
	case PID_HALT_TYPE:
		return "PID_HALT";
	case PID_INIT_TYPE:
		return "PID_INIT";
	case PID_RUN_TYPE:
		return "PID_RUN";
	case PID_SET_GAINS_TYPE:
		return "PID_SET_GAINS";
	case PID_STATUS_TYPE:
		return "PID_STATUS";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for PID_SET_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
void PID_SET_GAINS::update(CMS *cms)
{
	cms->update(Kp);
	cms->update(Ki);
	cms->update(Kd);

}


/*
*	NML/CMS Update function for PID_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
void PID_INIT::update(CMS *cms)
{
	cms->update(sample_time);

}


/*
*	NML/CMS Update function for PID_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
void PID_RUN::update(CMS *cms)
{
	cms->update(reference_input);

}


/*
*	NML/CMS Update function for PID_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
void PID_STATUS::update(CMS *cms)
{
	cms->update(plant_output);
	cms->update(ctrl_output);

}


/*
*	NML/CMS Update function for PID_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
void PID_HALT::update(CMS *cms)
{

}

/*
*	Constructor for PID_SET_GAINS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
PID_SET_GAINS::PID_SET_GAINS()
	: RCS_CMD_MSG(PID_SET_GAINS_TYPE,sizeof(PID_SET_GAINS))
{
	Kp = (double) 0;
	Ki = (double) 0;
	Kd = (double) 0;

}

/*
*	Constructor for PID_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
PID_INIT::PID_INIT()
	: RCS_CMD_MSG(PID_INIT_TYPE,sizeof(PID_INIT))
{
	sample_time = (double) 0;

}

/*
*	Constructor for PID_RUN
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
PID_RUN::PID_RUN()
	: RCS_CMD_MSG(PID_RUN_TYPE,sizeof(PID_RUN))
{
	reference_input = (double) 0;

}

/*
*	Constructor for PID_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
PID_STATUS::PID_STATUS()
	: RCS_STAT_MSG(PID_STATUS_TYPE,sizeof(PID_STATUS))
{
	plant_output = (double) 0;
	ctrl_output = (double) 0;

}

/*
*	Constructor for PID_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Sun Sep 12 18:34:54 EDT 1999
*/
PID_HALT::PID_HALT()
	: RCS_CMD_MSG(PID_HALT_TYPE,sizeof(PID_HALT))
{

}

