/*
pidn.hh

This C++ header file defines the NML Messages used for command and status by PID_MODULE
Template Version 1.1

MODIFICATIONS:
12-Sep-99	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef PIDN_HH
#define PIDN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define PID_STATUS_TYPE 1000
#define PID_HALT_TYPE 1001
#define PID_INIT_TYPE 1002
#define PID_RUN_TYPE 1003
#define PID_SET_GAINS_TYPE 1004
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class PID_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	PID_STATUS();

	// Constructor used by derived classes
	PID_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double plant_output;
  double ctrl_output;

};

// Command Classes

class PID_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	PID_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class PID_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	PID_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double sample_time;

};

class PID_RUN : public RCS_CMD_MSG
{
public:

	//Constructor
	PID_RUN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double reference_input;

};

class PID_SET_GAINS : public RCS_CMD_MSG
{
public:

	//Constructor
	PID_SET_GAINS();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double Kp;  // Proportional
  double Ki;  // Integral
  double Kd;  // Derivative


};

// Declare NML format function
extern int pidFormat(NMLTYPE, void *, CMS *);

#endif 	// PIDN_HH
