/*
	pid_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		PID_MODULE

	MODIFICATIONS:
	12-Sep-99	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "pid.hh"	// definition of PID_MODULE

// flag signifying main loop is to terminate
int pid_module_done = 0;

//signal handler for ^C
extern "C" void pid_module_quit(int sig);
void pid_module_quit(int sig)
{
	pid_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int pid_module_run();

int pid_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	PID_MODULE *pid = new PID_MODULE();

	// set the SIGINT handler
	signal(SIGINT, pid_module_quit);

	// enter main loop
	while(!pid_module_done)
	{
		pid->controller();

		timer->wait();
	}

	// Delete Modules
	delete pid;

	// Delete Timer
	delete timer;
}

